# Create audit log subscription

POST https://app.launchdarkly.com/api/v2/integrations/{integrationKey}
Content-Type: application/json

Create an audit log subscription.<br /><br />For each subscription, you must specify the set of resources you wish to subscribe to audit log notifications for. You can describe these resources using a custom role policy. To learn more, read [Custom role concepts](https://launchdarkly.com/docs/home/account/role-concepts).

Reference: https://launchdarkly.com/docs/api/integration-audit-log-subscriptions/create-subscription

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/integrations/{integrationKey}:
    post:
      operationId: create-subscription
      summary: Create audit log subscription
      description: >-
        Create an audit log subscription.<br /><br />For each subscription, you
        must specify the set of resources you wish to subscribe to audit log
        notifications for. You can describe these resources using a custom role
        policy. To learn more, read [Custom role
        concepts](https://launchdarkly.com/docs/home/account/role-concepts).
      tags:
        - subpackage_integrationAuditLogSubscriptions
      parameters:
        - name: integrationKey
          in: path
          description: The integration key
          required: true
          schema:
            type: string
            format: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Integration response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Integration'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestErrorRep'
        '401':
          description: Invalid access token
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedErrorRep'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorRep'
        '404':
          description: Invalid resource identifier
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorRep'
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedErrorRep'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/subscriptionPost'
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    StatementPostEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: StatementPostEffect
    StatementPost:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> field must be empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> field must be empty to use this field.
        effect:
          $ref: '#/components/schemas/StatementPostEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
      required:
        - effect
      title: StatementPost
    StatementPostList:
      type: array
      items:
        $ref: '#/components/schemas/StatementPost'
      title: StatementPostList
    subscriptionPost:
      type: object
      properties:
        name:
          type: string
          description: A human-friendly name for your audit log subscription.
        statements:
          $ref: '#/components/schemas/StatementPostList'
          description: >-
            The set of resources you wish to subscribe to audit log
            notifications for.
        'on':
          type: boolean
          description: Whether or not you want your subscription to actively send events.
        tags:
          type: array
          items:
            type: string
          description: An array of tags for this subscription.
        config:
          type: object
          additionalProperties:
            description: Any type
          description: >-
            The unique set of fields required to configure an audit log
            subscription integration of this type. Refer to the
            <code>formVariables</code> field in the corresponding
            <code>manifest.json</code> at
            https://github.com/launchdarkly/integration-framework/tree/main/integrations
            for a full list of fields for the integration you wish to configure.
        url:
          type: string
          description: >-
            Slack webhook receiver URL. Only necessary for legacy Slack webhook
            integrations.
        apiKey:
          type: string
          description: >-
            Datadog API key. Only necessary for legacy Datadog webhook
            integrations.
      required:
        - name
        - config
      title: subscriptionPost
    Link:
      type: object
      properties:
        href:
          type: string
          description: The URL of the link
        type:
          type: string
          description: The type of the link
      title: Link
    StatementEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: StatementEffect
    Statement:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/StatementEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
      required:
        - effect
      title: Statement
    ActionIdentifier:
      type: string
      title: ActionIdentifier
    AccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessDeniedReasonEffect
    AccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessDeniedReason
    AccessDenied:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessDeniedReason'
      required:
        - action
        - reason
      title: AccessDenied
    AccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessAllowedReasonEffect
    AccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessAllowedReason
    AccessAllowedRep:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessAllowedReason'
      required:
        - action
        - reason
      title: AccessAllowedRep
    Access:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/AccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/AccessAllowedRep'
      required:
        - denied
        - allowed
      title: Access
    UnixMillis:
      type: integer
      format: int64
      title: UnixMillis
    IntegrationStatusRep:
      type: object
      properties:
        statusCode:
          type: integer
        responseBody:
          type: string
        timestamp:
          $ref: '#/components/schemas/UnixMillis'
      title: IntegrationStatusRep
    IntegrationSubscriptionStatusRep:
      type: object
      properties:
        successCount:
          type: integer
        lastSuccess:
          $ref: '#/components/schemas/UnixMillis'
        lastError:
          $ref: '#/components/schemas/UnixMillis'
        errorCount:
          type: integer
        errors:
          type: array
          items:
            $ref: '#/components/schemas/IntegrationStatusRep'
      title: IntegrationSubscriptionStatusRep
    Integration:
      type: object
      properties:
        _links:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/Link'
          description: The location and content type of related resources
        _id:
          type: string
          description: The ID for this integration audit log subscription
        kind:
          type: string
          description: The type of integration
        name:
          type: string
          description: A human-friendly name for the integration
        config:
          type: object
          additionalProperties:
            description: Any type
          description: >-
            Details on configuration for an integration of this type. Refer to
            the <code>formVariables</code> field in the corresponding
            <code>manifest.json</code> for a full list of fields for each
            integration.
        statements:
          type: array
          items:
            $ref: '#/components/schemas/Statement'
          description: >-
            Represents a Custom role policy, defining a resource kinds filter
            the integration audit log subscription responds to.
        'on':
          type: boolean
          description: Whether the integration is currently active
        tags:
          type: array
          items:
            type: string
          description: An array of tags for this integration
        _access:
          $ref: '#/components/schemas/Access'
          description: Details on the allowed and denied actions for this subscription
        _status:
          $ref: '#/components/schemas/IntegrationSubscriptionStatusRep'
          description: Details on the most recent successes and errors for this integration
        url:
          type: string
          description: >-
            Slack webhook receiver URL. Only used for legacy Slack webhook
            integrations.
        apiKey:
          type: string
          description: Datadog API key. Only used for legacy Datadog webhook integrations.
      title: Integration
    InvalidRequestErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: InvalidRequestErrorRep
    UnauthorizedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: UnauthorizedErrorRep
    ForbiddenErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: ForbiddenErrorRep
    NotFoundErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: NotFoundErrorRep
    RateLimitedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: RateLimitedErrorRep
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/integrations/integrationKey"

payload = {
    "name": "Example audit log subscription.",
    "config": {
        "optional": "an optional property",
        "required": "the required property",
        "url": "https://example.com"
    },
    "statements": [
        {
            "effect": "allow",
            "resources": ["proj/*:env/*:flag/*;testing-tag"],
            "actions": ["*"]
        }
    ],
    "on": False,
    "tags": ["testing-tag"]
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/integrations/integrationKey';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"Example audit log subscription.","config":{"optional":"an optional property","required":"the required property","url":"https://example.com"},"statements":[{"effect":"allow","resources":["proj/*:env/*:flag/*;testing-tag"],"actions":["*"]}],"on":false,"tags":["testing-tag"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/integrations/integrationKey"

	payload := strings.NewReader("{\n  \"name\": \"Example audit log subscription.\",\n  \"config\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  },\n  \"statements\": [\n    {\n      \"effect\": \"allow\",\n      \"resources\": [\n        \"proj/*:env/*:flag/*;testing-tag\"\n      ],\n      \"actions\": [\n        \"*\"\n      ]\n    }\n  ],\n  \"on\": false,\n  \"tags\": [\n    \"testing-tag\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/integrations/integrationKey")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Example audit log subscription.\",\n  \"config\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  },\n  \"statements\": [\n    {\n      \"effect\": \"allow\",\n      \"resources\": [\n        \"proj/*:env/*:flag/*;testing-tag\"\n      ],\n      \"actions\": [\n        \"*\"\n      ]\n    }\n  ],\n  \"on\": false,\n  \"tags\": [\n    \"testing-tag\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.launchdarkly.com/api/v2/integrations/integrationKey")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Example audit log subscription.\",\n  \"config\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  },\n  \"statements\": [\n    {\n      \"effect\": \"allow\",\n      \"resources\": [\n        \"proj/*:env/*:flag/*;testing-tag\"\n      ],\n      \"actions\": [\n        \"*\"\n      ]\n    }\n  ],\n  \"on\": false,\n  \"tags\": [\n    \"testing-tag\"\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.launchdarkly.com/api/v2/integrations/integrationKey', [
  'body' => '{
  "name": "Example audit log subscription.",
  "config": {
    "optional": "an optional property",
    "required": "the required property",
    "url": "https://example.com"
  },
  "statements": [
    {
      "effect": "allow",
      "resources": [
        "proj/*:env/*:flag/*;testing-tag"
      ],
      "actions": [
        "*"
      ]
    }
  ],
  "on": false,
  "tags": [
    "testing-tag"
  ]
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/integrations/integrationKey");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Example audit log subscription.\",\n  \"config\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  },\n  \"statements\": [\n    {\n      \"effect\": \"allow\",\n      \"resources\": [\n        \"proj/*:env/*:flag/*;testing-tag\"\n      ],\n      \"actions\": [\n        \"*\"\n      ]\n    }\n  ],\n  \"on\": false,\n  \"tags\": [\n    \"testing-tag\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Example audit log subscription.",
  "config": [
    "optional": "an optional property",
    "required": "the required property",
    "url": "https://example.com"
  ],
  "statements": [
    [
      "effect": "allow",
      "resources": ["proj/*:env/*:flag/*;testing-tag"],
      "actions": ["*"]
    ]
  ],
  "on": false,
  "tags": ["testing-tag"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/integrations/integrationKey")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```